/*
 *    TTTTTTTTTTTTTT  HH          HH  OOOOOOOOOOOOOO  MM          MM
 *    TTTTTTTTTTTTTT  HH          HH  OOOOOOOOOOOOOO  MMM        MMM
 *          TT        HH          HH  OO          OO  MMMM      MMMM 
 *          TT        HH          HH  OO          OO  MM MM    MM MM
 *          TT        HH          HH  OO          OO  MM  MM  MM  MM 
 *          TT        HHHHHHHHHHHHHH  OO          OO  MM   MMMM   MM
 *          TT        HHHHHHHHHHHHHH  OO          OO  MM    MM    MM
 *          TT        HH          HH  OO          OO  MM          MM
 *          TT        HH          HH  OO          OO  MM          MM
 *          TT        HH          HH  OO          OO  MM          MM
 *          TT        HH          HH  OOOOOOOOOOOOOO  MM          MM
 *          TT        HH          HH  OOOOOOOOOOOOOO  MM          MM 
 *
 *                      l'émulateur Thomson TO7-70
 *
 *  Copyright (C) 1996 Sylvain Huet, 1999-2002 Eric Botcazou.
*   Copyright (C) 2016 Thomas Missonier
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

//Definition sap
#define SAP_HEADER_SIZE  66
#define SAP_SECT_SIZE   262
#define SAP_MAGIC_NUM  0xB3

#define NBDRIVE    4
#define NBTRACK   40
#define NBSECT    16
#define SECTSIZE 256

typedef struct {
    unsigned char format;
    unsigned char protection;
    unsigned char track;
    unsigned char sector;
    unsigned char data[SECTSIZE];
    unsigned char crc1sect;
    unsigned char crc2sect;
} sapsector_t;

/* table de calcul du CRC */
static short int crcpuk_temp;

// Header for disk.c
//static void crc_pukall(short int c);
//static void do_crc(sapsector_t *sapsector);
//static int verify_sap_lect(sapsector_t *sapsector);
//static int verify_sap_ecri(sapsector_t *sapsector);
//static int sap_get_sector(int drive, sapsector_t *sapsector);
//static int sap_put_sector(int drive, sapsector_t *sapsector);
//static int sap_format_track(int drive, int track, unsigned char filler_byte);
void ReadSector(int *cc);
void WriteSector(int *cc);
void DiskNop(int *cc);
static void BuildSectorMap(int *sector_map, int factor);
void FormatDrive(int *cc);
void InitDisk(void);
static int CheckFile(const char filename[], int mode);
int to7_DirectSetDrive(int drive);
int to7_LoadDisk(int drive, const char filename[]);
int to7_SetDiskMode(int drive, int mode);
const char* to7_GetDiskFilename(int drive);

